#!/usr/bin/perl

my $STATE_NONE         = 0;
my $STATE_IMPORT       = 1;
my $STATE_CHECKOUTHOT  = 2;
my $STATE_UPDATE       = 3;
my $STATE_COMMIT       = 4;
my $STATE_INDEX_0      = 5;
my $STATE_INDEX_1      = 6;
my $STATE_EOCOMMIT     = 7;
my $STATE_CHECKOUTCOLD = 8;

my $state = 0;

my $nimports = 0;
my $import = 0;
my $checkout_hot = 0;
my $checkout_cold = 0;
my $commit_lines = 0;

my $last_lines;
my $last_files;
my $last_recr;
my $update_recr = 0;
my $last_lr;

my $import_st;
my $checkout_st_0;
my $checkout_st_1;
my $checkout_recr;

my @commit_files;
my @commit_records;
my @update_records;

my @update_times_0;
my @update_times_1;
my @commit_times_0;
my @commit_times_1;

my @commit_st_0;
my @commit_st_1;
my @update_st_0;
my @update_st_1;

my @commit_sync_0;
my @commit_sync_1;

my @dispatch_c_0;
my @dispatch_c_1;
my @dispatch_u_0;
my @dispatch_u_1;

my @proc_c_0;
my @proc_c_1;
my @proc_u_0;
my @proc_u_1;

my @load_vl_u_0;
my @load_vl_u_1;
my @load_vl_c_0;
my @load_vl_c_1;

my $which = 0;
my $mark;

while (<>) {
  if ($state == $STATE_INDEX_0) {
    if ($_ =~ /^(\d+)/) {
      if ($1 > 0) { push @commit_files, $1; }
      $last_files = $1;
      $state = $STATE_INDEX_1;
    }
    next;
  }

  elsif ($_ =~ /view: \+(\d+)/) {
    if ($last_files != 0) {
      if ($state == $STATE_UPDATE) {
        if ($which == 0) { push @load_vl_u_0, $1; }
        if ($which == 1) { push @load_vl_u_1, $1; }
      }
      elsif ($state == $STATE_COMMIT) {
        if ($which == 0) { push @load_vl_c_0, $1; }
        if ($which == 1) { push @load_vl_c_1, $1; }
      }
      elsif ($state == $STATE_EOCOMMIT) {
        $state = STATE_NONE;
      }
    }
  }
  elsif ($_ =~ /lock: \+(\d+)/) {
    my $t = $1;
    if ($state == $STATE_UPDATE) {
      if ($last_files != 0) {
        if ($which == 0) { push @update_st_0, $t; }
        if ($which == 1) { push @update_st_1, $t; }
      }
    }
    elsif ($state == $STATE_COMMIT) {
      if ($last_files != 0) {
        if ($which == 0) { push @commit_st_0, $t; }
        if ($which == 1) { push @commit_st_1, $t; }
      }
    }
  }
  elsif ($_ =~ /dispatch: \+(\d+)/) {
    my $t = $1;
    if ($state == $STATE_UPDATE) {
      if ($last_files != 0) {
        if ($which == 0) { push @dispatch_u_0, $t; }
        if ($which == 1) { push @dispatch_u_1, $t; }
      }
    }
    elsif ($state == $STATE_COMMIT) {
      if ($last_files != 0) {
        if ($which == 0) { push @dispatch_c_0, $t; }
        if ($which == 1) { push @dispatch_c_1, $t; }
      }
    }
  }
  elsif ($_ =~ /commit: \+(\d+)/) {
    my $t = $1;
    if ($state == $STATE_COMMIT) {
      if ($last_files != 0) {
        if ($which == 0) { push @commit_sync_0, $t; }
        if ($which == 1) { push @commit_sync_1, $t; }
      }
    }
  }
  elsif ($_ =~ /process: \+(\d+)/) {
    my $t = $1;
    if ($state == $STATE_UPDATE) {
      if ($last_files != 0) {
        if ($which == 0) { push @proc_u_0, $t; }
        if ($which == 1) { push @proc_u_1, $t; }
      }
    }
    elsif ($state == $STATE_COMMIT ||
           $state == $STATE_EOCOMMIT) {
      if ($last_files != 0) {
        if ($which == 0) { push @proc_c_0, $t; }
        if ($which == 1) { push @proc_c_1, $t; }
      }
    }
  }

  elsif ($_ =~ /^[0-9.]+u [0-9.]+s ([0-9]+):([0-9][0-9]).([0-9][0-9])/) {
    my $t = $1*60+$2+$3/100;

    if ($state == $STATE_IMPORT) {
      $nimports++;
      $import += $t;
    }
    elsif ($state == $STATE_CHECKOUTHOT) {
      $checkout_hot += $t;
    }
    elsif ($state == $STATE_CHECKOUTCOLD) {
      $checkout_cold += $t;
    }
    elsif ($state == $STATE_COMMIT) {
      if ($last_files != 0) {
        if ($which == 0) { push @commit_times_0, $t; }
        if ($which == 1) { push @commit_times_1, $t; }
        print "$which c $t $last_files $last_recr\n";
      }
    }
    elsif ($state == $STATE_UPDATE) {
      if ($last_files != 0) {
        if ($which == 0) { push @update_times_0, $t; }
        if ($which == 1) { push @update_times_1, $t; }
        print "$which u $t $last_files $update_recr\n";
	push @update_records, $update_recr;
	$update_recr = 0;
      }
    }
  }
  elsif ($_ =~ /([0-9.]+) real/) {
    my $t = $1;
    if ($state == $STATE_IMPORT) {
      $nimports++;
      $import = $1;
    }
    elsif ($state == $STATE_CHECKOUTHOT) {
      $checkout_hot += $1;
    }
    elsif ($state == $STATE_CHECKOUTCOLD) {
      $checkout_cold += $1;
    }
    elsif ($state == $STATE_COMMIT) {
      if ($last_files != 0) {
	if ($which == 0) { push @commit_times_0, $t; }
        if ($which == 1) { push @commit_times_1, $t; }
        print "$which c $t $last_files $last_recr\n";
      }
    }
    elsif ($state == $STATE_UPDATE) {
      if ($last_files != 0) {
        if ($which == 0) { push @update_times_0, $t; }
        if ($which == 1) { push @update_times_1, $t; }
        print "$which u $t $last_files $update_recr\n";
	push @update_records, $update_recr;
	$update_recr = 0;
      }
    }
  }
  elsif ($_ =~ /wrote key/) {
    $state = $STATE_NONE;
  }
  elsif ($_ =~ /^Import$/) {
    $state = $STATE_IMPORT;
  }
  elsif ($_ =~ /^Checkout Hot/) {
    $state = $STATE_CHECKOUTHOT;
  }
  elsif ($_ =~ /^Checkout Cold/) {
    $state = $STATE_CHECKOUTCOLD;
  }
  elsif ($_ =~ /^Update Warm/) {
    $state = $STATE_UPDATE;
    if ($_ =~ /^Update Warm ([01])/) {
      $which = $1;
    }
  }
  elsif ($_ =~ /^Commit/) {
    $state = $STATE_COMMIT;
    if ($_ =~ /^Commit ([01])/) {
      $which = $1;
    }
  }
  elsif ($_ =~ /([0-9]+) records$/) {
    if ($state == $STATE_COMMIT) {
      push @commit_records, $1;
      $last_recr = $1;
      $update_recr += $1;
    }
  }
  elsif ($_ =~ /^\s+([0-9]+)\s+([0-9]+)\s+([0-9]+) diffs_([0-9_]+)/) {
    $mark = $4;
    $commit_lines += $1;
    $last_lines = $1;
  }
  elsif ($_ =~ /^\s+([0-9]+)\s+([0-9]+)\s+([0-9]+) patch-([0-9_]+)/) {
    $mark = $4;
    $commit_lines += $1;
    $last_lines = $1;
  }
  elsif ($_ =~ /^===== /) {
    $state = $STATE_INDEX_0;
  }
  elsif ($_ =~ /^Done Commit/) {
    $state = $STATE_EOCOMMIT;
  }
}

sub qunt {
  my ($m, @v) = @_;
  $i = $#v * $m;
  return $v[$i];
}

sub subtop {
  my @v = @_;
  if (0) {
    my @x;
    for (my $xxx = 0; $v[$xxx] < qunt(0.90,@v); $xxx++) { push @x, $v[$xxx]; }
    return @x;
  }
  else { return @v; }
}

sub sum {
  my @v = subtop (@_);
  $sum = 0;
  for ($i = 0; $i <= $#v; $i++) {
    $sum += $v[$i];
  }
  return $sum;
}

sub avg {
  my @v = subtop (@_);
  $sum = sum(@v);
  return $sum/($#v+1);
}

sub std {
  my @v = subtop (@_);
  $avg = avg(@v);
  $var = 0;
  for ($i = 0; $i <= $#v; $i++) {
    $var += (($v[$i]-$avg)**2);
  }
  return sqrt($var/($#v+1));
}

@commit_files = sort {$a <=> $b} @commit_files;
@commit_records = sort {$a <=> $b} @commit_records;
@update_records = sort {$a <=> $b} @update_records;

@update_times_0 = sort {$a <=> $b} @update_times_0;
@update_times_1 = sort {$a <=> $b} @update_times_1;
@commit_times_0 = sort {$a <=> $b} @commit_times_0;
@commit_times_1 = sort {$a <=> $b} @commit_times_1;

@update_st_0 = sort {$a <=> $b} @update_st_0;
@update_st_1 = sort {$a <=> $b} @update_st_1;
@commit_st_0 = sort {$a <=> $b} @commit_st_0;
@commit_st_1 = sort {$a <=> $b} @commit_st_1;

@dispatch_u_0 = sort {$a <=> $b} @dispatch_u_0;
@dispatch_u_1 = sort {$a <=> $b} @dispatch_u_1;
@dispatch_c_0 = sort {$a <=> $b} @dispatch_c_0;
@dispatch_c_1 = sort {$a <=> $b} @dispatch_c_1;

@proc_u_0 = sort {$a <=> $b} @proc_u_0;
@proc_u_1 = sort {$a <=> $b} @proc_u_1;
@proc_c_0 = sort {$a <=> $b} @proc_c_0;
@proc_c_1 = sort {$a <=> $b} @proc_c_1;

@commit_sync_0 = sort {$a <=> $b} @commit_sync_0;
@commit_sync_1 = sort {$a <=> $b} @commit_sync_1;

@load_vl_u_0 = sort {$a <=> $b} @load_vl_u_0;
@load_vl_u_1 = sort {$a <=> $b} @load_vl_u_1;
@load_vl_c_0 = sort {$a <=> $b} @load_vl_c_0;
@load_vl_c_1 = sort {$a <=> $b} @load_vl_c_1;


print "# machine c/u time files records snapshot_time sync/load_recr\n";
print "# $mark\n";

printf ("       import  %5.1f ", $import);
if ($nimports > 0) { printf ("(%4.1f)", $import/$nimports); }
printf ("\n");

printf ("     checkout  %5.1f ", $checkout_hot);
if ($nimports > 0) { printf ("(%4.1f)", $checkout_hot/$nimports); }
printf ("\n");

printf ("     checkout  %5.1f ", $checkout_cold);
if ($nimports > 0) { printf ("(%4.1f)", $checkout_cold/$nimports); }
printf ("\n");

printf ("    avg files  %5.1f\n", avg (@commit_files));
printf ("    med files  %5.1f\n", qunt (0.5, @commit_files));

if ($#commit_records >= 0) {
  printf ("    avg recrs  %5.1f\n", avg (@commit_records));
  printf ("    med recrs  %5.1f\n", qunt (0.5, @commit_records));
}

if ($#update_records >= 0) {
  printf ("    avg delts  %5.1f\n", avg (@update_records));
  printf ("    med delts  %5.1f\n", qunt (0.5, @update_records));
}

printf ("    machine 0\n");
  
if ($#commit_times_0 >= 0) {
  printf ("   sum commit  %5.1f ", sum (@commit_times_0));
  if ($nimports > 0) { printf ("(%4.1f)", sum(@commit_times_0)/$nimports); }
  printf ("\n");

  printf ("   avg commit  %5.1f (", avg (@commit_times_0));
  if ($#load_vl_c_0 >= 0)
    { printf ("v %4.1f ", avg (@load_vl_c_0)/1000); }
  if ($#commit_st_0 >= 0) 
    { printf ("l %4.1f ", avg (@commit_st_0)/1000); }
  if ($#dispatch_c_0 >= 0) 
    { printf ("d %4.1f ", avg (@dispatch_c_0)/1000); }
  if ($#commit_sync_0 >= 0) 
    { printf ("c %4.1f ", avg (@commit_sync_0)/1000); }
  if ($#proc_c_0 >= 0) 
    { printf ("p %4.1f ", avg (@proc_c_0)/1000); }
  print ")\n";
  
  printf ("   med commit  %5.1f (", qunt (0.5, @commit_times_0));
  if ($#load_vl_c_0 >= 0)
    { printf ("v %4.1f ", qunt (0.5, @load_vl_c_0)/1000); }
  if ($#commit_st_0 >= 0) 
    { printf ("l %4.1f ", qunt (0.5, @commit_st_0)/1000); }
  if ($#dispatch_c_0 >= 0) 
    { printf ("d %4.1f ", qunt (0.5, @dispatch_c_0)/1000); }
  if ($#commit_sync_0 >= 0) 
    { printf ("c %4.1f ", qunt (0.5, @commit_sync_0)/1000); }
  if ($#proc_c_0 >= 0) 
    { printf ("p %4.1f ", qunt (0.5, @proc_c_0)/1000); }
  print ")\n";
}

if ($#update_times_0 >= 0) {
  printf ("   sum update  %5.1f ", sum (@update_times_0));
  if ($nimports > 0) { printf ("(%4.1f)", sum(@update_times_0)/$nimports); }
  printf ("\n");

  printf ("   avg update  %5.1f (", avg (@update_times_0));
  if ($#load_vl_u_0 >= 0)
    { printf ("v %4.1f ", avg (@load_vl_u_0)/1000); }
  if ($#update_st_0 >= 0) 
    { printf ("l %4.1f ", avg (@update_st_0)/1000); }
  if ($#dispatch_u_0 >= 0) 
    { printf ("d %4.1f ", avg (@dispatch_u_0)/1000); }
  if ($#proc_u_0 >= 0) 
    { printf ("p %4.1f ", avg (@proc_u_0)/1000); }
  print ")\n";

  printf ("   med update  %5.1f (", qunt (0.5, @update_times_0));
  if ($#load_vl_u_0 >= 0)
    { printf ("v %4.1f ", qunt (0.5, @load_vl_u_0)/1000); }
  if ($#update_st_0 >= 0) 
    { printf ("l %4.1f ", qunt (0.5, @update_st_0)/1000); }
  if ($#dispatch_u_0 >= 0) 
    { printf ("d %4.1f ", qunt (0.5, @dispatch_u_0)/1000); }
  if ($#proc_u_0 >= 0) 
    { printf ("p %4.1f ", qunt (0.5, @proc_u_0)/1000); }
  print ")\n";
}

printf ("    machine 1\n");

if ($#commit_times_1 >= 0) {
  printf ("   sum commit  %5.1f ", sum(@commit_times_1));
  if ($nimports > 0) { printf ("(%4.1f)", sum(@commit_times_1)/$nimports); }
  printf ("\n");

  printf ("   avg commit  %5.1f (", avg (@commit_times_1));
  if ($#load_vl_c_1 >= 0)
    { printf ("v %4.1f ", avg (@load_vl_c_1)/1000); }
  if ($#commit_st_1 >= 0) 
    { printf ("l %4.1f ", avg (@commit_st_1)/1000); }
  if ($#dispatch_c_1 >= 0) 
    { printf ("d %4.1f ", avg (@dispatch_c_1)/1000); }
  if ($#commit_sync_1 >= 0) 
    { printf ("c %4.1f ", avg (@commit_sync_1)/1000); }
  if ($#proc_c_1 >= 0) 
    { printf ("p %4.1f ", avg (@proc_c_1)/1000); }
  print ")\n";
  
  printf ("   med commit  %5.1f (", qunt (0.5, @commit_times_1));
  if ($#load_vl_c_1 >= 0)
    { printf ("v %4.1f ", qunt (0.5, @load_vl_c_1)/1000); }
  if ($#commit_st_1 >= 0) 
    { printf ("l %4.1f ", qunt (0.5, @commit_st_1)/1000); }
  if ($#dispatch_c_1 >= 0) 
    { printf ("d %4.1f ", qunt (0.5, @dispatch_c_1)/1000); }
  if ($#commit_sync_1 >= 0) 
    { printf ("c %4.1f ", qunt (0.5, @commit_sync_1)/1000); }
  if ($#proc_c_1 >= 0) 
    { printf ("p %4.1f ", qunt (0.5, @proc_c_1)/1000); }
  print ")\n";
}

if ($#update_times_1 >= 0) {
  printf ("   sum update  %5.1f ", sum (@update_times_1));
  if ($nimports > 0) { printf ("(%4.1f)", sum(@update_times_1)/$nimports); }
  printf ("\n");

  printf ("   avg update  %5.1f (", avg (@update_times_1));
  if ($#load_vl_u_1 >= 0)
    { printf ("v %4.1f ", avg (@load_vl_u_1)/1000); }
  if ($#update_st_1 >= 0) 
    { printf ("l %4.1f ", avg (@update_st_1)/1000); }
  if ($#dispatch_u_1 >= 0) 
    { printf ("d %4.1f ", avg (@dispatch_u_1)/1000); }
  if ($#proc_u_1 >= 0) 
    { printf ("p %4.1f ", avg (@proc_u_1)/1000); }
  print ")\n";
  
  printf ("   med update  %5.1f (", qunt (0.5, @update_times_1));
  if ($#load_vl_u_1 >= 0)
    { printf ("v %4.1f ", qunt (0.5, @load_vl_u_1)/1000); }
  if ($#update_st_1 >= 0) 
    { printf ("l %4.1f ", qunt (0.5, @update_st_1)/1000); }
  if ($#dispatch_u_1 >= 0)
    { printf ("d %4.1f ", qunt (0.5, @dispatch_u_1)/1000); }
  if ($#proc_u_1 >= 0)
    { printf ("p %4.1f ", qunt (0.5, @proc_u_1)/1000); }
  print ")\n";
}

