#include "penviron.h"
#include "sfsmisc.h"
#include "async.h"
#include "str.h"

static char* defaults[] = {
  "PASTWATCH_TCPSOCKET", DEFAULT_PW_TCPSOCKET,
  "LSD_TCP_TIMEOUT", "10",
  "CFSRW_CONNTIMER", "5",
  "CFSRW_RPCWIN", "32",
  "CFSRW_RPCTIMER", "180"
};
static unsigned ndefaults = 5;


char* pgetenv(const char *name) {
  unsigned i;
  char* s = getenv(name);

  if (!s) {
    for(i=0; i<ndefaults; i++)
      if (!strcmp(name, defaults[i*2]))
	s = defaults[i*2 + 1];
  }

  return s;
}

str pget_pwroot() {

  char* pwhome = getenv("PASTWATCH_ROOT");
  if (pwhome) 
    return pwhome;

  // use default location
  str home = getenv("HOME");
  if (!home)
    fatal << "Could not find HOME environment variable.";

  strbuf b;
  b << home << "/.pastwatch";
  return str(b);
}

str pget_replicadir() {
  
  char* replica_dir = getenv("PASTWATCH_LOCAL_REPLICA");
  if (replica_dir) 
    return replica_dir;
  else
    fatal << "Environment variable PASTWATCH_LOCAL_REPLICA is undefined.  Please set PASTWATCH_LOCAL_REPLICA.  See the pastwatch(1) man page for more details.\n";
}
